var CalculoDaNecessidadeOLController = function (ScreenService, MessageService, General, restEngine, templateManager) {
    var self = this;
    var idutilconssoliol;
    var grupo;
    var arrayNeceComp;
    var nrseqOL;
    var parametrosParaSupri;
    
    this.getAgrupamentoProdutoOL = function(widget) {
        var nmsubgrprod = widget.getField('NMSUBGRPROD');
        nmsubgrprod.dataSourceFilter = [
            {"name": "CDFILIAL",    "value": widget.currentRow.CDFILIALOL, "operator": "="},
            {"name": "NRORG",       "value": getLocalVar('NRORG'),         "operator": "="},
            {"operator": "ORDER_BY", "name": [{"name": "CDSUBGRPROD", "direction": "ASC"}]}
        ];
        nmsubgrprod.reload();
    };
    
    this.validaFilialOL = function(args){
        if(!args.owner.field.widget.currentRow.CDFILIALOL) {
            MessageService.showMessageByCode("INFORMAR_OL");
            args.e.preventDefault();
            return false; 
        }
    };
    
    this.intervaloChange = function(field) {
        let widget = field.widget;
        widget.currentRow.DTINI = widget.currentRow.INTERVALO.start;
        widget.currentRow.DTFIM = widget.currentRow.INTERVALO.end;
    };

    
    this.setProdFinalMin = function(widget){
        var nmprodfin = widget.getField('NMPRODFIN');
        nmprodfin.dataSourceFilter = [
            {"name": "CDARVPROD",    "value": widget.currentRow.CDPRODINI, "operator": ">="},
            {"name": "NRORG",       "value": getLocalVar('NRORG'),         "operator": "="},
            {"operator": "ORDER_BY", "name": [{"name": "CDARVPROD", "direction": "ASC"}]}
        ];
        nmprodfin.reload();
    };
    
    var validaAcrecimos = function(field){
        if(field < 0 || field > 100) {
            ScreenService.showMessage(mensagem);
            return false;
        } else {
            return true;
        }
    };
    
    var validaProduto = function(prodInicial, prodFinal) {
        if (!General.comparaPratoProduto(prodInicial, prodFinal, getLocalVar('CDPICTPROD'))) {
            MessageService.showMessageByCode("PRODUTO_INICIAL_MENOR_IGUAL_FINAL");
            return false;
        }
        return true;
    };
    
    var validaProdutoFinal = function(row) { 
        var aux = 'ZZZZZZZZZZZZZZZZZZZZ';
        var str = row.CDPRODFIN;
        var produto = str + aux.substr(0, aux.length - str.length); 
        return produto;
    };
    
    var validaDataInicial = function(dtinicial) {
        if (moment(dtinicial, 'DD/MM/YYYY') < moment(getLocalVar('DTPROCESSA'), 'DD/MM/YYYY')) {
            MessageService.showMessageByCode("DATA_MAIOR_IGUAL_PROCESSAMENTO");
            return false;
        }
        return true;
    };
    
    
    this.setDadosTela = function (args){
        var widget = args.owner.getWidget('calculoNecessidadeComprasOL');
        var resp;
        
        General.callRestEngine("opl_solicitacao#/getCentralCompras", "Row", {}).then(function(response) {
            resp = response.dataset.data;
            
            const filter = [
                {
        			"name": "CDFILIAL",
        			"operator": "=",
        			"value": resp.CDFILIAL
        		},
        		{
        			"name": "NRORG",
        			"operator": "=",
        			"value": resp.NRORG
        		}
        	];
        	
            General.callRestEngine("opl#/crud/parasupri", "FilterData", filter).then(function(response) {
                parametrosParaSupri = response.dataset.parasupri[0];
            }).catch(function(error) {
                MessageService.showMessageByCode("ERR_GENERICO", { "PARAM": error.data.error });
            });
        }).catch(function(error) {
            if(error.data.error == "CDFILCENTCMP_NOT_REGISTERED") {
                MessageService.showMessageByCode(error.data.error);
            } else {
                MessageService.showMessageByCode("ERR_GENERICO", { "PARAM": error.data.error });
            }
        });
        
        General.callRestEngine('/setDadosCalculo', 'Row', widget.currentRow).then(function(calback) {
            var resposta = calback.dataset.resposta;
            idutilconssoliol = resposta.IDUTILCONSSOLIOL;
            grupo = resposta.CDGRUPPROD;
            
            if(resposta.IDGERACMPOLPER == 'S') {
                widget.getField("geraSolicitacaOL").isVisible = true;
            } else {
                widget.getField("geraSolicitacaOL").isVisible = false;
            }
            if(resposta.IDUTILCONSSOLIOLEXT == 'S') {
                widget.getField("geraConsolidacaoOL").isVisible = true;
            } else {
                widget.getField("geraConsolidacaoOL").isVisible = false;
            }
            
            widget.currentRow.geraConsolidacaoOL = 'T';
            widget.currentRow.geraSolicitacaOL = 'N';
        }.bind());                                                               
    };
    
    var setSubgrupo = function(row){
        if(row.naoConsidera == 'T'){
            return 'T';
        }  else{
            return row.NMSUBGRPROD.join('_');
        }
    };
    
    var dataSourceFilterSolicitacao = function(widget) {
		var filtro = [
			{
			    "name": "P_CDFILIAL",
			    "operator": "=",
			    "value": widget.currentRow.CDFILSOLI ? widget.currentRow.CDFILSOLI : null
			},
			{
			    "name": "P_DTINI",
			    "operator": "=",
			    "value": widget.currentRow.DTINI ? widget.currentRow.DTINI : null
			},
			{
			    "name": "P_DTFIN",
			    "operator": "=",
			    "value": widget.currentRow.DTFIM ? widget.currentRow.DTFIM : null
			},
			{
			    "name": "P_CDPRODUTOINI",
			    "operator": "=",
			    "value": widget.currentRow.CDPRODINI ? widget.currentRow.CDPRODINI : null
			},
			{
			    "name": "P_CDPRODUTOFIN",
			    "operator": "=",
			    "value": widget.currentRow.CDPRODFIN ? (angular.copy(widget.currentRow.CDPRODFIN) + "ZZZZZZZZZZZZZZZZZZZZ").substr(0, 20) : null
			},
			{
			    "name": "P_SUBGRUPO",
			    "operator": "=",
			    "value": setSubgrupo(widget.currentRow) ? setSubgrupo(widget.currentRow) : null
			}
		];
		return filtro;
	};
    
    var verificaSolicitacao = function(widget) {
        if(widget.isValid()) {
			var widgetSolic = widget.container.getWidget('sup07500_existemSolicitacoes');
			
			widget.currentRow.CDFILSOLI = widget.currentRow.CDFILIALOL;
			
			widgetSolic.dataSourceFilter = dataSourceFilterSolicitacao(widget); 
			widgetSolic.reload().then(function(callback) {
			    if(callback.dataset.resposta.length > 0) {
			        ScreenService.openPopup(widgetSolic);
			        
				    widgetSolic.activate();
			    } else {
			        calcula(widget);
			    }
			});
		}
    };
    
    var calcula = function(widget) {
        widget.currentRow.DATMOMENT = moment().format('DD/MM/YYYY');
        widget.currentRow.CDGRUPPROD = grupo;
        
        if(widget.currentRow.consPrevisaoConsumo == 'S') {
            self.CalcPrevCons(widget);
        } else {
            self.CalcNecesComp(widget);
        }
    };
    
    this.existemSolicitacoes = function(widget) {
        ScreenService.closePopup();
        
        widget.getParent().activate();
        
        calcula(widget.getParent());
    };
    
    var alteraValueInconsistencia = function(resposta) {
        return resposta.replaceAll('/', ' -');
    };
    
    var verificaInconsConsOL = function(widget) {
        if(widget.isValid()) {
            widget.currentRow.CDSUBGRUPO = setSubgrupo(widget.currentRow);
            widget.currentRow.geraConsolidacaoOL = Util.isEmptyOrBlank(widget.currentRow.geraConsolidacaoOL) ? 'T' : widget.currentRow.geraConsolidacaoOL;
            widget.currentRow.geraSolicitacaOL = Util.isEmptyOrBlank(widget.currentRow.geraSolicitacaOL) ? 'N' : widget.currentRow.geraSolicitacaOL;
            
            General.callRestEngine('/verificaConsOL', 'Row', widget.currentRow).then(function(callback) {
    			var widgetConsol = widget.container.getWidget('sup07500_verificaConsolidacaoOL');
    			
			    if(callback.dataset.relatIncons.length > 0) {
			        MessageService.confirmMessageByCode("INCONS_PROCESSO_CONSOLIDACAO").then(function (success) {
			            widgetConsol.dataSource.data = callback.dataset.relatIncons;
			            
			            for(var i = 0; i < callback.dataset.relatIncons.length; i++) {
                            callback.dataset.relatIncons[i].IDVERIFCONSOL = alteraValueInconsistencia(callback.dataset.relatIncons[i].IDVERIFCONSOL);
                        }
                        
			            ScreenService.openPopup(widgetConsol);
			            setTimeout(() => {
                            ScreenService.showLoader();
                	        MessageService.getMessageByCode('LABEL_POPUP_INCONSISTENCIA_CONSOLIDACAO_OL').then(function(response){
                                var label = response;
                                widgetConsol.label = label;
                                widgetConsol.redraw();
                                ScreenService.hideLoader();
                            });
                        }, 500);
			            
			            widgetConsol.reload();
				        widgetConsol.activate();
			        }, function(error) {
                        calculaNeceComp(widget);   
                    });
			    } else {
			        calculaNeceComp(widget); 
			    }
            });
		}
    };
    
    this.existemInconsistencias = function(widget) {
        ScreenService.closePopup();
        
        widget.getParent().activate();
        
        calculaNeceComp(widget.getParent());
    };
    
    var calculaNeceComp = function(widget) {
        widget.currentRow.DATMOMENT = moment().format('DD/MM/YYYY');
        widget.currentRow.CDGRUPPROD = grupo;
        
        if(widget.currentRow.consPrevisaoConsumo != 'S') {
            General.callRestEngine('/GetPrxNeceComp', 'Row', widget.currentRow).then(function(calculo) {
                nrseqOL = calculo.dataset.resposta[0].substr(0, 10);
                
                if(calculo.dataset.resposta[0].substr(-1) == 'N') {
                    MessageService.showMessageByCode("CALC_NAO_APUROU");
                } else {
                    if(calculo.dataset.resposta[1] == null) {
                        self.openConsolidacaoOL(widget);
                    } else {
                        MessageService.showMessageByCode("ERRO_ENCONTRADO", {"PARAM": calculo.dataset.resposta[1]});
                    }
                }
            }.bind()).catch(function(error) {
                var errorMessage = "Timeout";
                let textContentError = '';
                
                if(error.data) {
                    errorMessage = "ERR_GENERICO";
                    textContentError = error.data.error;
                }
                MessageService.showMessageByCode(errorMessage, { "PARAM": textContentError });
            });
        } else {
            openFilterAction(widget);   
        }
    };
    
    this.confirmaCalculo = function(widget) {
        var row = widget.currentRow;

        if(widget.isValid() && validaDataInicial(widget.currentRow.INTERVALO.start) && validaProduto(row.CDPRODINI, row.CDPRODFIN) && validaAcrecimos(General.valueToFloat(row.PEACRESCIMO))) {
            MessageService.confirmMessageByCode("CONFIRMA_CALCULO").then(function (success) {
                if(idutilconssoliol != 'S') {
                    var descParIdutilconssoliol = "UTIL_CONSOLIDACAO";
                    
                    MessageService.showMessageByCode("OPBLOCK_PARAMETRO_DESMARCADO", { "PARAM": descParIdutilconssoliol });
                    
                    return false;
                } else {
                    if (!row.PEACRESCIMO) {
                        row.PEACRESCIMO = 0;
                    }
                    
                    row.PRODUTOFIN = validaProdutoFinal(row);
                    row.GROUPFILI = '';
                    row.TCFILI = '';
                    
                    verificaSolicitacao(widget);
                }   
            });
        }
    };
    
    this.previsoesBloqueadas = function(widget){
        
        MessageService.confirmMessageByCode("CONF_CALC_PREVISOES_BLOCK").then(function (success) {
            ScreenService.closePopup();
            widget.getParent().activate();
            verificaSolicitacao(widget.getParent());

        }, function(error){
            ScreenService.closePopup();
            widget.getParent().activate();

        });
    };
    
    this.CalcPrevCons = function (widget) {
        General.callRestEngine('/previsaoConsumo', 'Row', widget.currentRow).then(function(calback) {
            if(calback.dataset.resposta.MSG == null) {
                self.CalcNecesComp(widget);
            } else {
                MessageService.showMessageByCode("PARAMETRO_DEFAULT");
            }
        });
    };
    
    this.CalcNecesComp = function (widget) {
        verificaInconsConsOL(widget);
    };
    
    this.excluiInconsistencias = function(widget){
        General.callRestEngine('/excluiInconsistencias', 'Row', widget.dataSource.data).then(function(calback) {
            ScreenService.closePopup();
            widget.getParent().activate();
        });
    };
    
    this.openConsolidacaoOL = function(widget) {
        var filtro = dataSourceFilterConsOL(widget);
        var cdfilial = widget.currentRow.CDFILIALOL + ' - ' + widget.currentRow.NMFILIALOL;
        var periodo = (widget.currentRow.INTERVALO.start) ? widget.currentRow.INTERVALO.start + ' até: ' + widget.currentRow.INTERVALO.end : "";

        ScreenService.openWindow('opl_solicitacao#sup07600_consolidacaoOL').then(function() {
			var widgetPrinc = templateManager.container.getWidget("sup07600_consolidacaoOL_GRID");
			var widgetFiltro = templateManager.container.getWidget("sup07600_consolidacaoOL_FILTER");
			var stripeWidget = templateManager.container.getWidget("stripeWidget");
			
			widgetFiltro.CDFILIALOL = widget.currentRow.CDFILIALOL;
			widgetFiltro.NMFILIALOL = widget.currentRow.NMFILIALOL;
			widgetFiltro.NRSEQUCONSOL = nrseqOL;
			widgetFiltro.CDFILIOPELOG = widget.currentRow.CDFILIALOL;
			widgetFiltro.NMFILIOPELOG = widget.currentRow.NMFILIALOL;
			widgetFiltro.DTCONSSOLOL = widget.currentRow.DATMOMENT.substr(0, 10);
			widgetFiltro.CDPRODINICONSOL = widget.currentRow.CDPRODINI;
			widgetFiltro.CDPRODFINCONSOL = widget.currentRow.CDPRODFIN;
			
			widgetFiltro.getField("NRSEQUCONSOL").reload();
			
			widgetFiltro.activate();
			
			widgetPrinc.dataSourceFilter = filtro;
			widgetPrinc.reload().then(function() {
				ScreenService.closePopup(widgetFiltro);
				
			    widgetPrinc.activate();
			    
			    widgetPrinc.list();
				
        	    widgetPrinc.getAction('excluir').isVisible = true;
				//widgetPrinc.activate();

                stripeWidget.getField('NRSEQUCONSOL').label = 'Consolidação: ' + nrseqOL;
                stripeWidget.getField('CDFILIOPELOG').label = 'Operador Logístico: ' + cdfilial;
                stripeWidget.getField('PERIODO').label = 'Período: ' + periodo;
                
				General.callRestEngine('/consOLController/setEstoqueConsOL', 'DataSet', widgetPrinc.dataSource.data).then(function(calback) {
                    widgetPrinc.dataSource.data = calback.dataset.resposta;
                    
                    if(calback.dataset.resposta[0].QTESTUTILCONSOL == 0 && calback.dataset.resposta[0].IDCALESTCONSOL == 'S') {
                        MessageService.showMessageByCode("OPBLOCK_NAO_HA_ESTOQUE");    
                    }
                });
			});
		});
    };
    
    var dataSourceFilterConsOL = function(widget) {
		var cdfiliopelog = widget.currentRow.CDFILIALOL;
        var cdprodini = widget.currentRow.CDPRODINI;
        var cdprodfin = widget.currentRow.CDPRODFIN;
		var filtro = [
			{
			    "name": "P_NRSEQUCONSOL",
			    "operator": "=",
			    "value": nrseqOL ? nrseqOL : null
			},
			{
			    "name": "P_CDFILSOLI",
			    "operator": "=",
			    "value": cdfiliopelog ? cdfiliopelog : null
			},
			{
			    "name": "P_CDPRODINI",
			    "operator": "=",
			    "value": cdprodini ? cdprodini : null
			},
			{
			    "name": "P_CDPRODFIN",
			    "operator": "=",
			    "value": cdprodfin ? cdprodfin : null
			}
		];
		
		return filtro;
	};
	
    var openFilterAction = function(widget) {
        var popupWidget = templateManager.container.getWidget('FILTRO');
        ScreenService.openPopup(popupWidget);
        popupWidget.newRow();
        if (popupWidget.inEditMode()) {
            popupWidget.newRow = function() {};
        }
        
    };
        
    this.criaRelatorio = function(widget) {
        var row = widget.getParent().container.getWidget('calculoNecessidadeComprasOL').currentRow;
        var reportName  = widget.currentRow.REPORT_NAME; 
        General.callRestEngine('/GetPrxNeceComp','Row',row).then(function(calculo) {
            nrseqOL = calculo.dataset.resposta[0].substr(0, 10);
            if(row.consPrevisaoConsumo == 'S'){
                if(calculo.dataset.resposta[2].length>0){
                    arrayNeceComp = calculo.dataset.resposta[2];
                    
                    widget.currentRow.DATAINI = widget.getParent().currentRow.INTERVALO.start;
                    widget.currentRow.DATAFIN = widget.getParent().currentRow.INTERVALO.end;
                    widget.currentRow.FILIPROC = getLocalVar('CDFILIAL');
                    widget.currentRow.NRNECECOMP = arrayNeceComp[0].PREVCONS;
                     widget.currentRow.CDFILIAL = '_';
                    for(var i=0;i<arrayNeceComp.length; i++) {
                         widget.currentRow.CDFILIAL = widget.currentRow.CDFILIAL.concat(arrayNeceComp[i].CDFILNECECMP.concat('_'));
                     }
                    if (widget.isValid()) {    
                        General.openReportPopup(widget, abreRelatorio, [widget, widget.currentRow, reportName]);  
                    }
                }
            }
        });
    };
    
    var abreRelatorio = function(widget, currentRow, reportName) {
   	    General.openReport('/previaNecessidadeOL', reportName, currentRow);
   	    
        ScreenService.closePopup();
        
        widget.getParent().activate();
        
        self.openConsolidacaoOL(widget.getParent().container.getWidget('calculoNecessidadeComprasOL'));
    };
    
    this.deletaTrabNece = function(widget) {
   	    General.callRestEngine('/delTrabNece','Row', arrayNeceComp).then(function(calculo) {
   	        widget.currentRow.NRNECECOMP = arrayNeceComp[0].PREVCONS;    
   	    });
    };
};

Configuration(function (ContextRegister) {
	ContextRegister.register('CalculoDaNecessidadeOLController', CalculoDaNecessidadeOLController);
});